package nckd.wnq01.wnq.scm.plugin.form;

import kd.bos.bill.AbstractMobBillPlugIn;
import kd.bos.bill.MobileBillShowParameter;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.form.CloseCallBack;
import kd.bos.form.IPageCache;
import kd.bos.form.ShowType;
import kd.bos.form.cardentry.CardEntry;
import kd.bos.form.control.AbstractGrid;
import kd.bos.form.control.events.ClickListener;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.orm.ORM;
import kd.fi.er.business.ext.enums.ErExtcaseEnum;
import kd.fi.er.business.ext.helper.ErExtHelper;
import kd.fi.er.common.ShowPageUtils;
import kd.fi.er.formplugin.daily.web.workflow.ErMobWorkFlowOtherViewEditUtils;
import kd.fi.er.formplugin.mobile.TripReimburseBill;
import kd.sdk.plugin.Plugin;

import java.util.*;

/**
 * 价格批量调整单移动端表单插件
 */
public class BatchPriceAdjMobEditPlugin extends AbstractMobBillPlugIn implements ClickListener, RowClickEventListener,Plugin {
    public static final String NCKD_PUTENTRY = "nckd_putentry";
    public static final String ENTRYENTITY = "entryentity";
    protected IPageCache pageCache;

    @Override
    public void initialize() {
        super.initialize();
        this.pageCache = this.getPageCache();
    }

    public void registerListener(EventObject e) {
        super.registerListener(e);
        AbstractGrid tripgrid = this.getView().getControl(NCKD_PUTENTRY);
        tripgrid.addRowClickListener(this);

        AbstractGrid entryentityGrid = this.getView().getControl(ENTRYENTITY);
        entryentityGrid.addRowClickListener(this);
    }


    @Override
    public void entryRowClick(RowClickEvent evt) {
        CardEntry source = (CardEntry)evt.getSource();
        switch (source.getKey()) {
            case NCKD_PUTENTRY:
                this.chooosePutEntryRow();
            case ENTRYENTITY:
                this.choooseTstjEntryRow();
            default:
        }
    }

    private void choooseTstjEntryRow() {
        this.setAllPriceInfoId();
        AbstractGrid grid = this.getView().getControl(ENTRYENTITY);
        int index = grid.getEntryState().getFocusRow();
        MobileBillShowParameter showParameter = new MobileBillShowParameter();
        showParameter.setFormId(this.getTstjEntryEditForm());
        Map<String, Object> mapCustomParam = new HashMap();
        mapCustomParam.put("index", index);
        mapCustomParam.put("status", 1);
        this.pageCache.put("viewPutEntryIndex", String.valueOf(index));

        ErMobWorkFlowOtherViewEditUtils.setWorkFlowParams(mapCustomParam, this.getView());
        ShowPageUtils.setFormStatusToCustomParam(mapCustomParam, this.getView());
        showParameter.setCustomParams(mapCustomParam);
        showParameter.getOpenStyle().setShowType(ShowType.Floating);
        //showParameter.setAppId("18XD+/5EDN8X");
        showParameter.setHasRight(true);
        showParameter.setCloseCallBack(new CloseCallBack(this, showParameter.getFormId()));
        //Object[] parma = new Object[]{this.getView(), this.getModel(), showParameter, mapCustomParam};

        this.getView().showForm(showParameter);
    }

    private void chooosePutEntryRow() {
        AbstractGrid grid = this.getView().getControl(ENTRYENTITY);
        int index = grid.getEntryState().getFocusRow();
        MobileBillShowParameter showParameter = new MobileBillShowParameter();
        showParameter.setFormId(this.getPutEntryEditForm());
        Map<String, Object> mapCustomParam = new HashMap<>();
        mapCustomParam.put("index", index);
        mapCustomParam.put("status", 1);
        this.pageCache.put("viewTstjEntryIndex", String.valueOf(index));

        ErMobWorkFlowOtherViewEditUtils.setWorkFlowParams(mapCustomParam, this.getView());
        ShowPageUtils.setFormStatusToCustomParam(mapCustomParam, this.getView());
        showParameter.setCustomParams(mapCustomParam);
        showParameter.getOpenStyle().setShowType(ShowType.Floating);
        //showParameter.setAppId("18XD+/5EDN8X");
        showParameter.setHasRight(true);
        showParameter.setCloseCallBack(new CloseCallBack(this, showParameter.getFormId()));
        //Object[] parma = new Object[]{this.getView(), this.getModel(), showParameter, mapCustomParam};

        this.getView().showForm(showParameter);

    }

    private String getPutEntryEditForm() {
        return "nckd_puentry_mb";
    }

    private String getTstjEntryEditForm() {
        return "nckd_tstjentry_mb";
    }

    private void setAllPriceInfoId() {
        DynamicObjectCollection ptEntry = this.getModel().getEntryEntity(NCKD_PUTENTRY);
        ptEntry.forEach((puentryItem) -> {
            this.setAndGetSelectedRowEntryId(puentryItem);
            DynamicObjectCollection expenseEntry = puentryItem.getDynamicObjectCollection("nckd_tjdetailentry");
            expenseEntry.forEach(this::setAndGetSelectedRowEntryId);
        });
        this.getModel().setValue(NCKD_PUTENTRY, ptEntry);
    }

    private Long setAndGetSelectedRowEntryId(DynamicObject entryEntity) {
        Long entryId = (Long)entryEntity.getPkValue();
        if (Objects.equals(entryId, 0L)) {
            entryId = ORM.create().genLongId(this.getView().getEntityId());
            entryEntity.set("id", entryId);
        }

        return entryId;
    }
}