package nckd.wnq01.wnq.scm.plugin.form;

import kd.bos.bill.AbstractMobBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.BizDataEventArgs;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.fi.er.business.servicehelper.CoreBaseBillServiceHelper;
import kd.fi.er.formplugin.util.EntryCopyUtil;
import kd.sdk.plugin.Plugin;

import java.util.EventObject;
import java.util.Map;

/**
 * 单据界面插件(移动端)
 */
public class TstjEntryMobEditPlugin extends AbstractMobBillPlugIn implements Plugin {



    @Override
    public void createNewData(BizDataEventArgs e) {
        super.createNewData(e);
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> mapCustomParam = showParameter.getCustomParams();
        int status = (Integer)mapCustomParam.get("status");
        IDataModel pModel = this.getView().getParentView().getModel();
        if (status == 1 && pModel.getDataEntity().getDataEntityType().getName().equals(this.getView().getEntityId())) {
            e.setDataEntity(pModel.getDataEntity());
        }
    }


    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        IDataModel model = this.getModel();
        CoreBaseBillServiceHelper.setFromStatus(this);
        IFormView parentView = this.getView().getParentView();
        IDataModel parentModel = parentView.getModel();
        Map<String, Object> mapCustomParam = this.getView().getFormShowParameter().getCustomParams();
        Integer status = null;
        if (mapCustomParam != null) {
            Object index = mapCustomParam.get("index");
            if (index != null) {
                this.getPageCache().put("parentViewTripIndex", index.toString());
            }

            status = (Integer)mapCustomParam.get("status");
        }

       if (status != null && status == 1) {
            this.updateTripentryInfo(model, parentModel, mapCustomParam);
        }

    }

    private void updateTripentryInfo(IDataModel model, IDataModel parentModel, Map<String, Object> mapCustomParam) {
        DynamicObjectCollection ptrip = (DynamicObjectCollection)parentModel.getDataEntity(true).get("entryentity");
        Object indexObj = mapCustomParam.get("index");
        if (indexObj != null) {
            int index = Integer.parseInt(indexObj.toString());
            DynamicObject viewTrip = ptrip.get(index);


            DynamicObjectCollection trip = (DynamicObjectCollection)this.getModel().getDataEntity(true).get("entryentity");
            trip.clear();
            EntryCopyUtil.copyEntry2TargetColl(trip, viewTrip);
        }

    }

}